Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision f34def7cdde1404608ef61377d53e30b1c5d0bdb)
+++ src/Makefile.am	(revision 315164b6c8e5a1302b98d6dd1aefc8ede4ec56b5)
@@ -1,4 +1,7 @@
 ATOMSOURCE = atom.cpp atom_atominfo.cpp atom_bondedparticle.cpp atom_bondedparticleinfo.cpp atom_graphnode.cpp atom_graphnodeinfo.cpp atom_particleinfo.cpp atom_trajectoryparticle.cpp atom_trajectoryparticleinfo.cpp
 ATOMHEADER = atom.hpp atom_atominfo.hpp atom_bondedparticle.hpp atom_bondedparticleinfo.hpp atom_graphnode.hpp atom_graphnodeinfo.hpp atom_particleinfo.hpp atom_trajectoryparticle.hpp atom_trajectoryparticleinfo.hpp
+
+LINALGSOURCE = gslmatrix.cpp gslvector.cpp linearsystemofequations.cpp
+LINALGHEADER = gslmatrix.hpp gslvector.hpp linearsystemofequations.hpp
 
 ANALYSISSOURCE = analysis_bonds.cpp analysis_correlation.cpp
@@ -11,12 +14,13 @@
 INCLUDES = -I$(top_srcdir)/src/unittests
 
-noinst_LIBRARIES = libmolecuilder.a
+noinst_LIBRARIES = libmolecuilder.a libgslwrapper.a
 bin_PROGRAMS = molecuilder joiner analyzer
 molecuilderdir = ${bindir}
 libmolecuilder_a_SOURCES = ${SOURCE} ${HEADER}
+libgslwrapper_a_SOURCES = ${LINALGSOURCE} ${LINALGHEADER}
 molecuilder_DATA = elements.db valence.db orbitals.db Hbonddistance.db Hbondangle.db
 molecuilder_LDFLAGS = $(BOOST_LIB)
 molecuilder_SOURCES = builder.cpp
-molecuilder_LDADD = libmolecuilder.a
+molecuilder_LDADD = libmolecuilder.a libgslwrapper.a
 joiner_SOURCES = joiner.cpp datacreator.cpp parser.cpp datacreator.hpp helpers.hpp parser.hpp periodentafel.hpp
 joiner_LDADD = libmolecuilder.a 
@@ -28,5 +32,5 @@
 FORCE:
 $(srcdir)/.git-version: FORCE
-	@if (test -d $(top_srcdir)/../.git && cd $(srcdir) && git describe --tags HEAD) > .git-version-t 2>/dev/null \
+	@if (test -d $(top_srcdir)/../.git && cd $(srcdir) && git describe HEAD) > .git-version-t 2>/dev/null \
 	  && ! diff .git-version-t $(srcdir)/.git-version >/dev/null 2>&1; then \
 	  mv -f .git-version-t $(srcdir)/.git-version; \
Index: src/analysis_correlation.cpp
===================================================================
--- src/analysis_correlation.cpp	(revision f34def7cdde1404608ef61377d53e30b1c5d0bdb)
+++ src/analysis_correlation.cpp	(revision 315164b6c8e5a1302b98d6dd1aefc8ede4ec56b5)
@@ -10,4 +10,5 @@
 #include "analysis_correlation.hpp"
 #include "element.hpp"
+#include "info.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
@@ -28,4 +29,5 @@
 PairCorrelationMap *PairCorrelation(MoleculeListClass * const &molecules, const element * const type1, const element * const type2 )
 {
+  Info FunctionInfo(__func__);
   PairCorrelationMap *outmap = NULL;
   double distance = 0.;
@@ -77,4 +79,5 @@
 PairCorrelationMap *PeriodicPairCorrelation(MoleculeListClass * const &molecules, const element * const type1, const element * const type2, const int ranges[NDIM] )
 {
+  Info FunctionInfo(__func__);
   PairCorrelationMap *outmap = NULL;
   double distance = 0.;
@@ -154,4 +157,5 @@
 CorrelationToPointMap *CorrelationToPoint(MoleculeListClass * const &molecules, const element * const type, const Vector *point )
 {
+  Info FunctionInfo(__func__);
   CorrelationToPointMap *outmap = NULL;
   double distance = 0.;
@@ -190,4 +194,5 @@
 CorrelationToPointMap *PeriodicCorrelationToPoint(MoleculeListClass * const &molecules, const element * const type, const Vector *point, const int ranges[NDIM] )
 {
+  Info FunctionInfo(__func__);
   CorrelationToPointMap *outmap = NULL;
   double distance = 0.;
@@ -243,4 +248,5 @@
 CorrelationToSurfaceMap *CorrelationToSurface(MoleculeListClass * const &molecules, const element * const type, const Tesselation * const Surface, const LinkedCell *LC )
 {
+  Info FunctionInfo(__func__);
   CorrelationToSurfaceMap *outmap = NULL;
   double distance = 0;
@@ -261,5 +267,5 @@
         Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl;
         if ((type == NULL) || (Walker->type == type)) {
-          triangle = Surface->FindClosestTriangleToPoint(Walker->node, LC );
+          triangle = Surface->FindClosestTriangleToVector(Walker->node, LC );
           if (triangle != NULL) {
             distance = DistanceToTrianglePlane(Walker->node, triangle);
@@ -288,4 +294,5 @@
 CorrelationToSurfaceMap *PeriodicCorrelationToSurface(MoleculeListClass * const &molecules, const element * const type, const Tesselation * const Surface, const LinkedCell *LC, const int ranges[NDIM] )
 {
+  Info FunctionInfo(__func__);
   CorrelationToSurfaceMap *outmap = NULL;
   double distance = 0;
@@ -320,5 +327,5 @@
                 checkX.AddVector(&periodicX);
                 checkX.MatrixMultiplication(FullMatrix);
-                triangle = Surface->FindClosestTriangleToPoint(&checkX, LC );
+                triangle = Surface->FindClosestTriangleToVector(&checkX, LC );
                 if (triangle != NULL) {
                   distance = DistanceToTrianglePlane(&checkX, triangle);
@@ -342,4 +349,5 @@
 double GetBin ( const double value, const double BinWidth, const double BinStart )
 {
+  Info FunctionInfo(__func__);
   double bin =(double) (floor((value - BinStart)/BinWidth));
   return (bin*BinWidth+BinStart);
@@ -353,4 +361,5 @@
 void OutputCorrelation( ofstream * const file, const BinPairMap * const map )
 {
+  Info FunctionInfo(__func__);
   *file << "# BinStart\tCount" << endl;
   for (BinPairMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
@@ -365,4 +374,5 @@
 void OutputPairCorrelation( ofstream * const file, const PairCorrelationMap * const map )
 {
+  Info FunctionInfo(__func__);
   *file << "# BinStart\tAtom1\tAtom2" << endl;
   for (PairCorrelationMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
@@ -377,4 +387,5 @@
 void OutputCorrelationToPoint( ofstream * const file, const CorrelationToPointMap * const map )
 {
+  Info FunctionInfo(__func__);
   *file << "# BinStart\tAtom::x[i]-point.x[i]" << endl;
   for (CorrelationToPointMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
@@ -392,4 +403,5 @@
 void OutputCorrelationToSurface( ofstream * const file, const CorrelationToSurfaceMap * const map )
 {
+  Info FunctionInfo(__func__);
   *file << "# BinStart\tTriangle" << endl;
   for (CorrelationToSurfaceMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
Index: src/analyzer.cpp
===================================================================
--- src/analyzer.cpp	(revision f34def7cdde1404608ef61377d53e30b1c5d0bdb)
+++ src/analyzer.cpp	(revision 315164b6c8e5a1302b98d6dd1aefc8ede4ec56b5)
@@ -7,4 +7,6 @@
 
 //============================ INCLUDES ===========================
+
+#include <cstring>
 
 #include "datacreator.hpp"
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision f34def7cdde1404608ef61377d53e30b1c5d0bdb)
+++ src/bondgraph.cpp	(revision 315164b6c8e5a1302b98d6dd1aefc8ede4ec56b5)
@@ -35,5 +35,5 @@
 /** Parses the bond lengths in a given file and puts them int a matrix form.
  * Allocates \a MatrixContainer for BondGraph::BondLengthMatrix, using MatrixContainer::ParseMatrix(),
- * but only if parsing is successfull. Otherwise variable is left as NULL.
+ * but only if parsing is successful. Otherwise variable is left as NULL.
  * \param *out output stream for debugging
  * \param filename file with bond lengths to parse
Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision f34def7cdde1404608ef61377d53e30b1c5d0bdb)
+++ src/boundary.cpp	(revision 315164b6c8e5a1302b98d6dd1aefc8ede4ec56b5)
@@ -654,9 +654,9 @@
  * \param *out output stream for debugging
  * \param *mol molecule with atoms and bonds
- * \param *&TesselStruct Tesselation with boundary triangles
+ * \param *TesselStruct Tesselation with boundary triangles
  * \param *filename prefix of filename
  * \param *extraSuffix intermediate suffix
  */
-void StoreTrianglesinFile(const molecule * const mol, const Tesselation *&TesselStruct, const char *filename, const char *extraSuffix)
+void StoreTrianglesinFile(const molecule * const mol, const Tesselation * const TesselStruct, const char *filename, const char *extraSuffix)
 {
 	Info FunctionInfo(__func__);
@@ -789,4 +789,6 @@
  * \param configuration contains box dimensions
  * \param distance[NDIM] distance between filling molecules in each direction
+ * \param boundary length of boundary zone between molecule and filling mollecules
+ * \param epsilon distance to surface which is not filled
  * \param RandAtomDisplacement maximum distance for random displacement per atom
  * \param RandMolDisplacement maximum distance for random displacement per filler molecule
@@ -794,5 +796,5 @@
  * \return *mol pointer to new molecule with filled atoms
  */
-molecule * FillBoxWithMolecule(MoleculeListClass *List, molecule *filler, config &configuration, double distance[NDIM], double RandomAtomDisplacement, double RandomMolDisplacement, bool DoRandomRotation)
+molecule * FillBoxWithMolecule(MoleculeListClass *List, molecule *filler, config &configuration, const double distance[NDIM], const double boundary, const double RandomAtomDisplacement, const double RandomMolDisplacement, const bool DoRandomRotation)
 {
 	Info FunctionInfo(__func__);
@@ -817,9 +819,8 @@
   for (MoleculeList::iterator ListRunner = List->ListOfMolecules.begin(); ListRunner != List->ListOfMolecules.end(); ListRunner++) {
     Log() << Verbose(1) << "Pre-creating linked cell lists for molecule " << *ListRunner << "." << endl;
-    LCList[i] = new LinkedCell((*ListRunner), 5.); // get linked cell list
-    if (TesselStruct[i] == NULL) {
-      Log() << Verbose(1) << "Pre-creating tesselation for molecule " << *ListRunner << "." << endl;
-      FindNonConvexBorder((*ListRunner), TesselStruct[i], (const LinkedCell *&)LCList[i], 5., NULL);
-    }
+    LCList[i] = new LinkedCell((*ListRunner), 10.); // get linked cell list
+    Log() << Verbose(1) << "Pre-creating tesselation for molecule " << *ListRunner << "." << endl;
+    TesselStruct[i] = NULL;
+    FindNonConvexBorder((*ListRunner), TesselStruct[i], (const LinkedCell *&)LCList[i], 5., NULL);
     i++;
   }
@@ -835,13 +836,7 @@
   FillerDistance.Init(distance[0], distance[1], distance[2]);
   FillerDistance.InverseMatrixMultiplication(M);
-  Log() << Verbose(1) << "INFO: Grid steps are ";
-  for(int i=0;i<NDIM;i++) {
+  for(int i=0;i<NDIM;i++)
     N[i] = (int) ceil(1./FillerDistance.x[i]);
-    Log() << Verbose(1) << N[i];
-    if (i != NDIM-1)
-      Log() << Verbose(1)<< ", ";
-    else
-      Log() << Verbose(1) << "." << endl;
-  }
+  Log() << Verbose(1) << "INFO: Grid steps are " << N[0] << ", " << N[1] << ", " << N[2] << "." << endl;
 
   // go over [0,1]^3 filler grid
@@ -859,8 +854,15 @@
           // get linked cell list
           if (TesselStruct[i] == NULL) {
-            eLog() << Verbose(1) << "TesselStruct of " << (*ListRunner) << " is NULL. Didn't we pre-create it?" << endl;
+            eLog() << Verbose(0) << "TesselStruct of " << (*ListRunner) << " is NULL. Didn't we pre-create it?" << endl;
             FillIt = false;
           } else {
-            FillIt = FillIt && (!TesselStruct[i]->IsInnerPoint(CurrentPosition, LCList[i]));
+            const double distance = (TesselStruct[i]->GetDistanceSquaredToSurface(CurrentPosition, LCList[i]));
+            FillIt = FillIt && (distance > boundary*boundary);
+            if (FillIt) {
+              Log() << Verbose(1) << "INFO: Position at " << CurrentPosition << " is outer point." << endl;
+            } else {
+              Log() << Verbose(1) << "INFO: Position at " << CurrentPosition << " is inner point or within boundary." << endl;
+              break;
+            }
             i++;
           }
@@ -931,4 +933,9 @@
       }
   Free(&M);
+
+  // output to file
+  TesselStruct[0]->LastTriangle = NULL;
+  StoreTrianglesinFile(Filling, TesselStruct[0], "Tesselated", ".dat");
+
   for (size_t i=0;i<List->ListOfMolecules.size();i++) {
   	delete(LCList[i]);
@@ -1041,4 +1048,10 @@
 //  TesselStruct->RemoveDegeneratedTriangles();
 
+  // check envelope for consistency
+  status = CheckListOfBaselines(TesselStruct);
+
+  // store before correction
+  StoreTrianglesinFile(mol, (const Tesselation *&)TesselStruct, filename, "");
+
   // correct degenerated polygons
   TesselStruct->CorrectAllDegeneratedPolygons();
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision f34def7cdde1404608ef61377d53e30b1c5d0bdb)
+++ src/boundary.hpp	(revision 315164b6c8e5a1302b98d6dd1aefc8ede4ec56b5)
@@ -36,5 +36,5 @@
 #define DEBUG 1
 #define DoSingleStepOutput 0
-#define SingleStepWidth 1
+#define SingleStepWidth 10
 
 #define DistancePair pair < double, atom* >
@@ -49,5 +49,5 @@
 
 double ConvexizeNonconvexEnvelope(class Tesselation *&TesselStruct, const molecule * const mol, const char * const filename);
-molecule * FillBoxWithMolecule(MoleculeListClass *List, molecule *filler, config &configuration, double distance[NDIM], double RandAtomDisplacement, double RandMolDisplacement, bool DoRandomRotation);
+molecule * FillBoxWithMolecule(MoleculeListClass *List, molecule *filler, config &configuration, const double distance[NDIM], const double boundary, const double RandomAtomDisplacement, const double RandomMolDisplacement, const bool DoRandomRotation);
 void FindConvexBorder(const molecule* const mol, Tesselation *&TesselStruct, const LinkedCell *LCList, const char *filename);
 Vector* FindEmbeddingHole(MoleculeListClass *mols, molecule *srcmol);
@@ -58,5 +58,5 @@
 void PrepareClustersinWater(config *configuration, molecule *mol, double ClusterVolume, double celldensity);
 bool RemoveAllBoundaryPoints(class Tesselation *&TesselStruct, const molecule * const mol, const char * const filename);
-void StoreTrianglesinFile(const molecule * const mol, const Tesselation *&TesselStruct, const char *filename, const char *extraSuffix);
+void StoreTrianglesinFile(const molecule * const mol, const Tesselation * const TesselStruct, const char *filename, const char *extraSuffix);
 double VolumeOfConvexEnvelope(class Tesselation *TesselStruct, class config *configuration);
 
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision f34def7cdde1404608ef61377d53e30b1c5d0bdb)
+++ src/builder.cpp	(revision 315164b6c8e5a1302b98d6dd1aefc8ede4ec56b5)
@@ -49,4 +49,6 @@
 
 using namespace std;
+
+#include <cstring>
 
 #include "analysis_correlation.hpp"
@@ -1410,12 +1412,14 @@
             Log() << Verbose(0) << "\t-B xx xy xz yy yz zz\tBound atoms by domain with given symmetric matrix of (xx,xy,xz,yy,yz,zz)." << endl;
             Log() << Verbose(0) << "\t-c x1 x2 x3\tCenter atoms in domain with a minimum distance to boundary of (x1,x2,x3)." << endl;
-            Log() << Verbose(0) << "\t-C\tPair Correlation analysis." << endl;
+            Log() << Verbose(0) << "\t-C <Z> <output> <bin output>\tPair Correlation analysis." << endl;
             Log() << Verbose(0) << "\t-d x1 x2 x3\tDuplicate cell along each axis by given factor." << endl;
             Log() << Verbose(0) << "\t-D <bond distance>\tDepth-First-Search Analysis of the molecule, giving cycles and tree/back edges." << endl;
             Log() << Verbose(0) << "\t-e <file>\tSets the databases path to be parsed (default: ./)." << endl;
             Log() << Verbose(0) << "\t-E <id> <Z>\tChange atom <id>'s element to <Z>, <id> begins at 0." << endl;
-            Log() << Verbose(0) << "\t-f/F <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl;
+            Log() << Verbose(0) << "\t-f <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl;
+            Log() << Verbose(0) << "\t-F <dist_x> <dist_y> <dist_z> <epsilon> <randatom> <randmol> <DoRotate>\tFilling Box with water molecules." << endl;
             Log() << Verbose(0) << "\t-g <file>\tParses a bond length table from the given file." << endl;
             Log() << Verbose(0) << "\t-h/-H/-?\tGive this help screen." << endl;
+            Log() << Verbose(0) << "\t-I\t Dissect current system of molecules into a set of disconnected (subgraphs of) molecules." << endl;
             Log() << Verbose(0) << "\t-L <step0> <step1> <prefix>\tStore a linear interpolation between two configurations <step0> and <step1> into single config files with prefix <prefix> and as Trajectories into the current config file." << endl;
             Log() << Verbose(0) << "\t-m <0/1>\tCalculate (0)/ Align in(1) PAS with greatest EV along z axis." << endl;
@@ -1575,16 +1579,4 @@
                 else {
                   Log() << Verbose(2) << "File found and parsed." << endl;
-                  // @TODO rather do the dissection afterwards
-//                  mol->SetNameFromFilename(argv[argptr]);
-//                  molecules->ListOfMolecules.remove(mol);
-//                  molecules->DissectMoleculeIntoConnectedSubgraphs(mol,&configuration);
-//                  delete(mol);
-//                  if (molecules->ListOfMolecules.size() != 0) {
-//                    for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
-//                      if ((*ListRunner)->ActiveFlag) {
-//                        mol = *ListRunner;
-//                        break;
-//                      }
-//                  }
                   configPresent = present;
                 }
@@ -1665,4 +1657,21 @@
               //argptr+=1;
               break;
+            case 'I':
+              Log() << Verbose(1) << "Dissecting molecular system into a set of disconnected subgraphs ... " << endl;
+              // @TODO rather do the dissection afterwards
+              molecules->DissectMoleculeIntoConnectedSubgraphs(mol,&configuration);
+              mol = NULL;
+              if (molecules->ListOfMolecules.size() != 0) {
+                for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
+                  if ((*ListRunner)->ActiveFlag) {
+                    mol = *ListRunner;
+                    break;
+                  }
+              }
+              if (mol == NULL) {
+                mol = *(molecules->ListOfMolecules.begin());
+                mol->ActiveFlag = true;
+              }
+              break;
             case 'C':
               if (ExitFlag == 0) ExitFlag = 1;
@@ -1672,5 +1681,4 @@
                 performCriticalExit();
               } else {
-                SaveFlag = false;
                 ofstream output(argv[argptr+1]);
                 ofstream binoutput(argv[argptr+2]);
@@ -1692,5 +1700,5 @@
                 counter = 0;
                 for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
-                  Actives[counter] = (*BigFinder)->ActiveFlag;
+                  Actives[counter++] = (*BigFinder)->ActiveFlag;
                   (*BigFinder)->ActiveFlag = (*BigFinder == Boundary) ? false : true;
                 }
@@ -1705,5 +1713,5 @@
                 binoutput.close();
                 for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++)
-                  (*BigFinder)->ActiveFlag = Actives[counter];
+                  (*BigFinder)->ActiveFlag = Actives[counter++];
                 Free(&Actives);
                 delete(LCList);
@@ -1728,7 +1736,7 @@
             case 'F':
               if (ExitFlag == 0) ExitFlag = 1;
-              if (argptr+5 >=argc) {
+              if (argptr+6 >=argc) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for filling box with water: -F <dist_x> <dist_y> <dist_z> <randatom> <randmol> <DoRotate>" << endl;
+                eLog() << Verbose(0) << "Not enough or invalid arguments given for filling box with water: -F <dist_x> <dist_y> <dist_z> <boundary> <randatom> <randmol> <DoRotate>" << endl;
                 performCriticalExit();
               } else {
@@ -1738,25 +1746,30 @@
                 molecule *filler = new molecule(periode);;
                 molecule *Filling = NULL;
-                atom *second = NULL, *third = NULL;
+//                atom *second = NULL, *third = NULL;
                 first = new atom();
-                first->type = periode->FindElement(1);
-                first->x.Init(0.441, -0.143, 0.);
+                first->type = periode->FindElement(5);
+                first->x.Zero();
                 filler->AddAtom(first);
-                second = new atom();
-                second->type = periode->FindElement(1);
-                second->x.Init(-0.464, 1.137, 0.0);
-                filler->AddAtom(second);
-                third = new atom();
-                third->type = periode->FindElement(8);
-                third->x.Init(-0.464, 0.177, 0.);
-                filler->AddAtom(third);
-                filler->AddBond(first, third, 1);
-                filler->AddBond(second, third, 1);
+//                first = new atom();
+//                first->type = periode->FindElement(1);
+//                first->x.Init(0.441, -0.143, 0.);
+//                filler->AddAtom(first);
+//                second = new atom();
+//                second->type = periode->FindElement(1);
+//                second->x.Init(-0.464, 1.137, 0.0);
+//                filler->AddAtom(second);
+//                third = new atom();
+//                third->type = periode->FindElement(8);
+//                third->x.Init(-0.464, 0.177, 0.);
+//                filler->AddAtom(third);
+//                filler->AddBond(first, third, 1);
+//                filler->AddBond(second, third, 1);
                 // call routine
                 double distance[NDIM];
                 for (int i=0;i<NDIM;i++)
                   distance[i] = atof(argv[argptr+i]);
-                Filling = FillBoxWithMolecule(molecules, filler, configuration, distance, atof(argv[argptr+3]), atof(argv[argptr+4]), atoi(argv[argptr+5]));
+                Filling = FillBoxWithMolecule(molecules, filler, configuration, distance, atof(argv[argptr+3]), atof(argv[argptr+4]), atof(argv[argptr+5]), atoi(argv[argptr+6]));
                 if (Filling != NULL) {
+                  Filling->ActiveFlag = false;
                   molecules->insert(Filling);
                 }
@@ -2107,5 +2120,5 @@
                 if (volume != -1)
                   ExitFlag = 255;
-                  eLog() << Verbose(0) << "Not enough arguments given for suspension: -u <density>" << endl;
+                  eLog() << Verbose(0) << "Not enough or invalid arguments given for suspension: -u <density>" << endl;
                   performCriticalExit();
               } else {
Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision f34def7cdde1404608ef61377d53e30b1c5d0bdb)
+++ src/config.cpp	(revision 315164b6c8e5a1302b98d6dd1aefc8ede4ec56b5)
@@ -6,4 +6,5 @@
 
 #include <stdio.h>
+#include <cstring>
 
 #include "atom.hpp"
@@ -27,5 +28,5 @@
     char number1[8];
     char number2[8];
-    char *dummy1, *dummy2;
+    const char *dummy1, *dummy2;
     //Log() << Verbose(0) << s1 << "  " << s2 << endl;
     dummy1 = strchr(s1, '_')+sizeof(char)*5;  // go just after "Ion_Type"
@@ -1074,6 +1075,6 @@
   // don't do this here ...
   //MolList->DissectMoleculeIntoConnectedSubgraphs(mol,this);
-
-  delete(mol);
+  //delete(mol);
+
   delete(FileBuffer);
 };
@@ -2123,5 +2124,5 @@
               }
               line++;
-            } while (dummy1 != NULL && (dummy1[0] == '#') || (dummy1[0] == '\n'));
+            } while ((dummy1 != NULL) && ((dummy1[0] == '#') || (dummy1[0] == '\n')));
             dummy = dummy1;
           } else { // simple int, strings or doubles start in the same line
